KDE 4.9 PyKDE API Reference

- KDE's Python API

# KTimeZoneData Class Reference

`from PyKDE4.kdecore import *`

## Detailed Description

Base class for the parsed data returned by a KTimeZoneSource class.

It contains all the data available from the KTimeZoneSource class, including, when available, a complete list of daylight savings time changes and leap seconds adjustments.

This base class can be instantiated, but contains no data.

Base class for parsed time zone data

See also:
  KTimeZone, KTimeZoneSource

Author:
  David Jarvie <djarvie@kde.org>.

## Methods

| __init__ (self)
| __init__ (self, KTimeZoneData c)
QByteArray | abbreviation (self, QDateTime utcDateTime)
[QByteArray] | abbreviations (self)
KTimeZoneData | clone (self)
bool | hasTransitions (self)
KTimeZone.LeapSeconds | leapSecondChange (self, QDateTime utc)
[KTimeZone.LeapSeconds] | leapSecondChanges (self)
[KTimeZone.Phase] | phases (self)
int | previousUtcOffset (self)
| setLeapSecondChanges (self, [KTimeZone.LeapSeconds] adjusts)
| setPhases (self, [KTimeZone.Phase] phases, int previousUtcOffset)
| setPhases (self, [KTimeZone.Phase] phases, KTimeZone.Phase previousPhase)
| setTransitions (self, [KTimeZone.Transition] transitions)
int, int secondIndex, bool validTime | transitionIndex (self, QDateTime dt)
[QDateTime] | transitionTimes (self, KTimeZone.Phase phase, QDateTime start=QDateTime(), QDateTime end=QDateTime())
[KTimeZone.Transition] | transitions (self, QDateTime start=QDateTime(), QDateTime end=QDateTime())
[int] | utcOffsets (self)

## Method Documentation

__init__ | ( |  | self ) |

__init__ | ( | self, |
|  | KTimeZoneData | c
| ) |  |  |

QByteArray abbreviation | ( | self, |
|  | QDateTime | utcDateTime
| ) |  |  |

Returns the time zone abbreviation current at a specified time.

Parameters:

  | utcDateTime | UTC date/time. An error occurs if utcDateTime.timeSpec() is not Qt.UTC.

Returns:
  time zone abbreviation, or empty string if error

See also:
  abbreviations()

[QByteArray] abbreviations | ( |  | self ) |

Returns the complete list of time zone abbreviations. This may include translations.

Returns:
  the list of abbreviations. In this base class, it consists of the single string "UTC".

See also:
  abbreviation()

KTimeZoneData clone | ( |  | self ) |

Creates a new copy of this object. The caller is responsible for deleting the copy. Derived classes must reimplement this method to return a copy of the calling instance.

Returns:
  copy of this instance

bool hasTransitions | ( |  | self ) |

Return whether daylight saving transitions are available for the time zone.

The base class returns false.

Returns:
  true if transitions are available, false if not

See also:
  transitions(), transition()

KTimeZone.LeapSeconds leapSecondChange | ( | self, |
|  | QDateTime | utc
| ) |  |  |

Find the leap second adjustment which is applicable at a given UTC time.

Parameters:

  | utc | UTC date/time. An error occurs if utc.timeSpec() is not Qt.UTC.

Returns:
  leap second adjustment, or invalid if utc is earlier than the first leap second adjustment or utc is a local time

[KTimeZone.LeapSeconds] leapSecondChanges | ( |  | self ) |

Return all leap second adjustments, in time order.

Note that some time zone data sources (such as system time zones accessed via the system libraries) may not provide information on leap second adjustments. In such cases, this method will return an empty list.

Returns:
  list of adjustments

[KTimeZone.Phase] phases | ( |  | self ) |

Return all daylight savings time phases.

Note that some time zone data sources (such as system time zones accessed via the system libraries) may not allow a list of daylight savings time changes to be compiled easily. In such cases, this method will return an empty list.

Returns:
  list of phases

int previousUtcOffset | ( |  | self ) |

Returns the UTC offset to use before the start of data for the time zone.

Returns:
  UTC offset

setLeapSecondChanges | ( | self, |
|  | [KTimeZone.LeapSeconds] | adjusts
| ) |  |  |

Initialise the leap seconds adjustment list.

Parameters:

  | adjusts | list of adjustments

See also:
  leapSecondChanges()

setPhases | ( | self, |
|  | [KTimeZone.Phase] | phases,
|  | int | previousUtcOffset
| ) |  |  |

Initialise the daylight savings time phase list. This setPhases() variant should be used when the time zone abbreviation used before the start of the first phase is not known.

Parameters:

  | phases | list of phases
  | previousUtcOffset | UTC offset to use before the start of the first phase

See also:
  phases()

setPhases | ( | self, |
|  | [KTimeZone.Phase] | phases,
|  | KTimeZone.Phase | previousPhase
| ) |  |  |

Initialise the daylight savings time phase list. This setPhases() variant should be used when the time zone abbreviation used before the start of the first phase is not known.

Parameters:

  | phases | list of phases
  | previousUtcOffset | UTC offset to use before the start of the first phase

See also:
  phases()

setTransitions | ( | self, |
|  | [KTimeZone.Transition] | transitions
| ) |  |  |

Initialise the daylight savings time transition list.

Parameters:

  | transitions | list of transitions

See also:
  transitions()

int, int secondIndex, bool validTime transitionIndex | ( | self, |
|  | QDateTime | dt
| ) |  |  |

Find the index to the last daylight savings time transition at or before a given UTC or local time. The return value is the index into the transition list returned by transitions().

Because of daylight savings time shifts, a local time may occur twice or may not occur at all. In the former case, the transitions at or before both occurrences of dt may optionally be calculated and returned in secondIndex. The latter case may optionally be detected by use of validTime.

Parameters:

  | dt | date/time. dt.timeSpec() may be set to Qt.UTC or Qt.LocalTime.
  | secondIndex | if non-null, and the dt occurs twice, receives the index to the transition for the second occurrence. Otherwise, it is set the same as the return value.
  | validTime | if non-null, is set to false if dt does not occur, or to true otherwise

Returns:
  index into the time zone transition list, or -1 either if dt is either outside the defined range of the transition data or if dt does not occur

See also:
  transition(), transitions(), hasTransitions()

[QDateTime] transitionTimes | ( | self, |
|  | KTimeZone.Phase | phase,
|  | QDateTime | start=QDateTime(),
|  | QDateTime | end=QDateTime()
| ) |  |  |

Return the times of all daylight saving transitions to a given time zone phase, in time order. If desired, the times returned may be restricted to a specified time range.

Note that some time zone data sources (such as system time zones accessed via the system libraries) may not allow a list of daylight saving time changes to be compiled easily. In such cases, this method will return an empty list.

Parameters:

  | phase | time zone phase
  | start | start UTC date/time, or invalid date/time to return all transitions up to end. start.timeSpec() must be Qt.UTC, else start will be considered invalid.
  | end | end UTC date/time, or invalid date/time for no end. end.timeSpec() must be Qt.UTC, else end will be considered invalid.

Returns:
  ordered list of transition times

See also:
  hasTransitions(), transition(), transitions()

[KTimeZone.Transition] transitions | ( | self, |
|  | QDateTime | start=QDateTime(),
|  | QDateTime | end=QDateTime()
| ) |  |  |

Return all daylight saving transitions, in time order. If desired, the transitions returned may be restricted to a specified time range.

Note that some time zone data sources (such as system time zones accessed via the system libraries) may not allow a list of daylight saving time changes to be compiled easily. In such cases, this method will return an empty list.

Parameters:

  | start | start date/time, or invalid date/time to return all transitions up to end. start.timeSpec() must be Qt.UTC, else start will be considered invalid.
  | end | end date/time, or invalid date/time for no end. end.timeSpec() must be Qt.UTC, else end will be considered invalid.

Returns:
  list of transitions, in time order

See also:
  hasTransitions(), transition(), transitionTimes()

[int] utcOffsets | ( |  | self ) |

Returns the complete list of UTC offsets for the time zone, if the time zone's source makes such information readily available. If compiling a complete list would require significant processing, an empty list is returned instead.

Returns:
  sorted list of UTC offsets, or empty list if not readily available. In this base class, it consists of the single value 0.